#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <tcl.h>

int TkXext_XErrorHandler (ClientData cdata, XErrorEvent *event) {
 char funcBuf[300];
 char reqBuf[300];
 char code[300];
 Display *dis = (Display *) cdata;
 
 sprintf (code, "%d", event->error_code);
  
 XGetErrorDatabaseText (dis, "XRequest", code, "non-standard function()", funcBuf, sizeof (funcBuf));
 XGetErrorText (dis, event->error_code, reqBuf, sizeof(reqBuf));
 fprintf (stderr, "X error: when %s was called causing %s\n", funcBuf, reqBuf);
 
 if (event->resourceid > 0) {
  fprintf (stderr, "The resource involved has an id of: %ld\n", event->resourceid);
 }
 
 return /*don't exit*/ 0;
}
