#include "TkXext.h"
 
int TkXext_MovePointer TCL_OBJ_CMD_ARGS {
 int newX;
 int newY;
 Display *dis;
 Window root;
 Tk_Window tkwin;
 int screenNum;

 if (objc != 3) {
  Tcl_WrongNumArgs (interp, 1, objv, "x y");
  return TCL_ERROR;
 }

 if (TCL_OK != Tcl_GetIntFromObj (interp, objv[1], &newX)) {
  return TCL_ERROR;
 }

 if (TCL_OK != Tcl_GetIntFromObj (interp, objv[2], &newY)) {
  return TCL_ERROR;
 }

 tkwin = Tk_MainWindow (interp);
 Tk_MakeWindowExist (tkwin);

 screenNum = Tk_ScreenNumber (tkwin);

 dis = Tk_Display (tkwin);
 root = RootWindow (dis, screenNum);

 XWarpPointer (dis,
  root,
  root,
  0, 0,
  DisplayWidth (dis, screenNum),
  DisplayHeight (dis, screenNum),
  newX, newY
 );


 XFlush (dis);

 return TCL_OK;
}
