#include "TkXext.h"

int TkXext_SendKeyPress TCL_OBJ_CMD_ARGS {
 Display *dis;
 Tk_Window tkwin;
 KeyCode key;
 unsigned long ulks;
 KeySym ks;
 
 /*TkXext.send.key.press KeySym*/
 if (2 != objc) {
  Tcl_WrongNumArgs (interp, 1, objv, "KeySym");
  return TCL_ERROR;
 }

 tkwin = Tk_MainWindow (interp);
 Tk_MakeWindowExist (tkwin);
 dis = Tk_Display (tkwin);

 if (TCL_OK != Tcl_GetLongFromObj (interp, objv[1], (long *)&ulks))
  return TCL_ERROR;

 ks = ulks;
 key = XKeysymToKeycode (dis, ks);

 if (0 == key) {
  Tcl_SetResult (interp, "unable to convert KeySym to KeyCode", TCL_STATIC);
  return TCL_ERROR;
 }

 XTestFakeKeyEvent (dis, key, 1, 0);
 XFlush (dis);

 return TCL_OK;
}
