#include "TkXext.h"

int TkXext_StringToWindow (Tcl_Interp *interp, char *s, Window *wPtr) {
 int i;
 int sLen; 
 int c;


 if (0 == strcmp ("root", s)) {
  *wPtr = DefaultRootWindow (Tk_Display (Tk_MainWindow (interp)));
  return TCL_OK;
 }

 sLen = strlen (s);

 for (i = 0; i < sLen; ++i) {
  c = s[i];
  if ('x' == c || isxdigit (c)) {
   continue;
  }
  Tcl_SetResult (interp, "bad Window/XID", TCL_STATIC);
  return TCL_ERROR;
 }
 
 sscanf (s, "%lx", (unsigned long *) wPtr);
 return TCL_OK; 
}
