#include "TkXext.h"
#include "string.to.window.h"

int TkXext_SendString TCL_OBJ_CMD_ARGS {
 Tcl_UniChar *strToSend;
 Display *dis;
 int strToSendLen;
 int screenNum;
 Tk_Window tkwin;
 KeySym shift;
 int i;

 /*TkXext.send.string UnicodeString*/
 if (2 != objc) {
  Tcl_WrongNumArgs (interp, 1, objv, "UnicodeString");
  return TCL_ERROR;
 }

 tkwin = Tk_MainWindow (interp);
 Tk_MakeWindowExist (tkwin);
 dis = Tk_Display (tkwin);
 screenNum = Tk_ScreenNumber (tkwin);

 strToSend = Tcl_GetUnicodeFromObj (objv[1], &strToSendLen);
 shift = XKeysymToKeycode (dis, XK_Shift_L);
  
  
 for (i = 0; i < strToSendLen; ++i) {
  Tcl_UniChar c = strToSend[i];
  KeyCode kc;

  /*
  fprintf (stderr, "c is control %d\n", Tcl_UniCharIsControl (c));
  fprintf (stderr, "c is punct %d\n", Tcl_UniCharIsPunct (c));
  */

  if (Tcl_UniCharIsUpper (c)) {
   XTestFakeKeyEvent (dis, shift, 1, 0);
  }

  kc = XKeysymToKeycode (dis, (KeySym) c);
  XTestFakeKeyEvent (dis, kc, 1, 0);
 
  if (Tcl_UniCharIsUpper (c)) {
   XTestFakeKeyEvent (dis, shift, 0, 0);
  }
  
  XTestFakeKeyEvent (dis, kc, 0, 0);
 }
 
 XFlush (dis);
 return TCL_OK;
}
